# target Zedboard/Zybo v2 FPGA
create_project -force synth synth_project -part xc7z020clg484-1;
set_property simulator_language Verilog [current_project];
# too high fanout may result in non ending syntheses
#set_property STEPS.SYNTH_DESIGN.ARGS.FANOUT_LIMIT 100 [get_runs synth_1];
add_files -norecurse ./TOP_MODULE;
add_files -fileset constrs_1 -norecurse tmp/constraints.xdc;
update_compile_order -fileset sources_1;

#define max thread number to one, as parallelism will be controled from scala
set_param general.maxThreads 1;

launch_runs synth_1 -jobs 1;

# waiting for synthesis to complete
wait_on_run synth_1;

# timing summary
open_run synth_1;
report_timing -file TIMING_REPORT;
